#ifndef _SNIFFED_PACKET_H
#define _SNIFFED_PACKET_H

#include "../scanner_module.h" /* boolean */

/* describes a sniffed packet */

struct sniffed_packet_descr_t{
	
	/* source and subject may differ 
	 * since a firewall with ip 'source'
	 * may report that a packet sent to 'subject'
	 * was not delivered.
	 */
	
	__be32            src;
	__be32            subject;							
	
	__be16            icmp_seq_num;
	__be16            icmp_id;	
	
	/* unreach-fields contain information
	 * about packets which generated dest-unreachables
	 */
	
	__be16            unreach_data;
	__be16            port;

	/* tcp-sequence-numbers */
	
	__be32            tcp_seq;
	__be32            tcp_ack_seq;			
	
	u8               protocol;
	u8               icmp_type;	
	u8               icmp_code;
	boolean           tcp_syn;	
	boolean           tcp_ack;
	boolean           tcp_rst;
	
	u8               unreach_protocol;
	
	struct timespec   time_received;	

};

struct sniffed_packet_descr_t *new_sniffed_packet_descr(void);

#endif
