#!/usr/bin/env python

# Given a scan-log, plots the cwnd-graph

import Gnuplot, Gnuplot.funcutils
import sys

# Make sure user has supplied scan-log-filename

if len(sys.argv) != 2:
    print "Usage: " + sys.argv[0] + " <scan_log_file>"
    sys.exit(1)

scan_log_fname = sys.argv[1]

try:
    scan_log_file = open(scan_log_fname)
except:
    print "Error opening scan-log-file"
    sys.exit(1)

# Create gnuplot-object

g = Gnuplot.Gnuplot()
g.title("PortBunny CWND-graph")
g.ylabel('CWND [packets]')
g.xlabel('Time [ns]')
g('set data style lines')


# Extract cwnds from scan-log-file

cwnd_dict = dict()
plot_tuple = ()
start_time_ns = 0

for line in scan_log_file:
    args = line.split(' ')
    
    if args[0] == 'INFO' and args[1] == 'CWND':
        if not cwnd_dict.has_key(args[2]):
            cwnd_dict[args[2]] = []            

        if start_time_ns == 0:
            start_time_ns = int(args[6])

        cwnd_dict[args[2]].append([int(args[6]) - start_time_ns, float(args[4]) / 10000])                    

for host in cwnd_dict.keys():
    plot_tuple = plot_tuple + (Gnuplot.PlotItems.Data(cwnd_dict[host], title=host + "-cwnd"),)
    

g.plot(*(plot_tuple))
raw_input('press any  key')
