#!/usr/bin/env python

# Given a scan-log, plots the rtt-graph

import Gnuplot, Gnuplot.funcutils
import sys

# Make sure user has supplied scan-log-filename

if len(sys.argv) != 2:
    print "Usage: " + sys.argv[0] + " <scan_log_file>"
    sys.exit(1)

scan_log_fname = sys.argv[1]

try:
    scan_log_file = open(scan_log_fname)
except:
    print "Error opening scan-log-file"
    sys.exit(1)

# Create gnuplot-object

g = Gnuplot.Gnuplot()
g.title("PortBunny RTT-graph")
g.ylabel('average RTT [ns]')
g.xlabel('Time [ns]')
g('set data style lines')


# Extract cwnds from scan-log-file

rtt_dict = dict()
plot_tuple = ()
start_time_ns = 0


for line in scan_log_file:
    args = line.split(' ')
        
    if args[0] == 'INFO' and args[1] == 'TIMEOUT':

        if not rtt_dict.has_key(args[2]):
            rtt_dict[args[2]] = []

        if start_time_ns == 0:
            start_time_ns = int(args[5])

        rtt_dict[args[2]].append([int(args[5]) - start_time_ns, float(args[4])])        


for host in rtt_dict.keys():
    plot_tuple = plot_tuple + (Gnuplot.PlotItems.Data(rtt_dict[host], title=host + "-rtt"),)

    

g.plot(*(plot_tuple))
raw_input('press any  key')
