#!/usr/bin/env python

# Given a scan-log, plots the "scan-throughput graph"

import Gnuplot, Gnuplot.funcutils
import sys

# Make sure user has supplied scan-log-filename

if len(sys.argv) != 2:
    print "Usage: " + sys.argv[0] + " <scan_log_file>"
    sys.exit(1)

scan_log_fname = sys.argv[1]

try:
    scan_log_file = open(scan_log_fname)
except:
    print "Error opening scan-log-file"
    sys.exit(1)

# Create gnuplot-object

g = Gnuplot.Gnuplot()
g.title("PortBunny Scan-throughput-graph")
g.ylabel('Results/s')
g.xlabel('Time [ns]')
g('set data style lines')


# Extract cwnds from scan-log-file

tput_dict = dict()
plot_tuple = ()
start_time_ns = 0

delta_ns = 50000000
frame_beg_ns = 0
nresults = 0

for line in scan_log_file:
    args = line.split(' ')
    
    if args[0] == 'INFO' and args[1] == 'TRIGGER_RECEIVED':
        if not tput_dict.has_key(args[2]):
            tput_dict[args[2]] = []            

        if start_time_ns == 0:
            start_time_ns = int(args[6])
            frame_beg_ns = start_time_ns

        cur_time = int(args[6])
        
        if cur_time - frame_beg_ns >= delta_ns:            

            tput_dict[args[2]].append([cur_time - start_time_ns, ( float(nresults + 1) * 10**9 ) /(cur_time - frame_beg_ns)  ])                    
            frame_beg_ns = cur_time
            nresults = 0
        else:
            nresults = nresults + 1
        
        


for host in tput_dict.keys():
    plot_tuple = plot_tuple + (Gnuplot.PlotItems.Data(tput_dict[host], title=host + "-scan-throughput"),)
    

g.plot(*(plot_tuple))
raw_input('press any  key')
